--Remove the double dashes to disable alerts for that achievement
local notified = {
--"gunpowder_glory",
--"expert_landing",
--"hostage_situation",
--"sound_of_silence",
--"hot_lava_2",
--"get_off_my_property",
--"private_party",
--"basement_dwellers",
--"crowd_control",
--"bullet_dodger",
--"king_of_the_hill",
--"let_them_watch",
--"matrix_with_lasers",
--"bushido",
--"stalker",
--"keep_clear_of_the_windows",
--"i_am_the_one_who_knocks",
--"caution_wet_floors",
--"oppressor",
--"fuck_it_were_walking",
--"making_a_statement",
--"cardio_training",
--"out_of_bounds",
--"you_shall_not_pass",
--"master_of_floatation",
--"keep_breathing_that_fresh_air",
--"low_murder_rate",
""
}

core:module("CoreElementToggle")
core:import("CoreMissionScriptElement")

ElementToggle = ElementToggle or class(CoreMissionScriptElement.MissionScriptElement)

local original_function = ElementToggle.on_executed
local colour_alert = Color.green
local colour_fail = Color.yellow

local difficulties = {
	"easy",
	"normal",
	"hard",
	"overkill",
	"overkill_145",
	"easy_wish",
	"overkill_290",
	"sm_wish"
}

function difficulty_to_index(difficulty)
	return table.index_of(difficulties, difficulty)
end

local fuck_it_were_walking_counter = 0
local cardio_training_flag = nil

function ElementToggle:on_executed(...)
	if not self._values.enabled then
		return
	end
	
	local level_id = Global.game_settings.level_id
	
	if level_id == "bex" then
		if not table.contains(notified, "gunpowder_glory") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and self._values.toggle == "off" and (self._id == 103702 or self._id == 103704) then
			table.insert(notified, "gunpowder_glory")
			
			if self._id == 103702 then
				notify("Gunpowder Glory", "Enemy entered fountain", colour_fail)
			elseif self._id == 103704 then
				notify("Gunpowder Glory", "Go loud before entering bank", colour_fail)
			end
		end
	elseif level_id == "pbr2" then
		if not table.contains(notified, "expert_landing") and difficulty_to_index(Global.game_settings.difficulty) >= 7 and self._values.toggle == "off" and self._id == 103475 then
			table.insert(notified, "expert_landing")
			
			notify("Expert Landing", "Player too low", colour_fail)
		end
	elseif level_id == "family" then
		if not table.contains(notified, "hostage_situation") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and self._values.toggle == "off" and self._id == 102205 then
			table.insert(notified, "hostage_situation")
			
			notify("Hostage Situation", "Civi left or died in store", colour_fail)
		end
	elseif level_id == "arena" then
		if not table.contains(notified, "sound_of_silence") and self._values.toggle == "off" and self._id == 102704 then
			table.insert(notified, "sound_of_silence")
			
			notify("Sound of Silence", "Someone died", colour_fail)
		elseif not table.contains(notified, "fuck_it_were_walking") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and self._values.toggle == "off" and self._id == 102694 then
		
			fuck_it_were_walking_counter = fuck_it_were_walking_counter + 1
			
			if fuck_it_were_walking_counter == 2 then
				table.insert(notified, "fuck_it_were_walking")
				
				notify("Fuck It, We're Walking", "Vent or zipline used", colour_fail)
			end
		end
	elseif level_id == "election_day_1" then
		if not table.contains(notified, "hot_lava_2") and self._values.toggle == "off" and self._id == 100469 then
			table.insert(notified, "hot_lava_2")
			
			notify("Hot Lava 2.0", "Player touched ground", colour_fail)
		end
	elseif level_id == "rvd1" then
		if not table.contains(notified, "get_off_my_property") and self._values.toggle == "off" and self._id == 100839 then
			table.insert(notified, "get_off_my_property")
			
			notify("Get Off My Property", "Enemy in warehouse", colour_fail)
		end
	elseif level_id == "jewelry_store" then
		if not table.contains(notified, "private_party") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and self._values.toggle == "off" and self._id == 100624 then
			table.insert(notified, "private_party")
			
			notify("Private Party", "Enemy entered store", colour_fail)
		end
	elseif level_id == "pal" then
		if not table.contains(notified, "basement_dwellers") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and self._values.toggle == "off" and self._id == 103194 then
			table.insert(notified, "basement_dwellers")
			
			notify("Basement Dwellers", "Enemy entered print room", colour_fail)
		elseif not table.contains(notified, "crowd_control") and self._values.toggle == "off" and self._id == 103200 then
			table.insert(notified, "crowd_control")
			
			notify("Crowd Control", "Civi died or escaped", colour_fail)
		end
	elseif level_id == "escape_street" then
		if not table.contains(notified, "bullet_dodger") and self._values.toggle == "off" and self._id == 101872 then
			table.insert(notified, "bullet_dodger")
			
			notify("Bullet Dodger", "Sniper died", colour_fail)
		end
	elseif level_id == "escape_park_day" or level_id == "escape_park" then
		if not table.contains(notified, "king_of_the_hill") and self._values.toggle == "off" and self._id == 101297 then
			table.insert(notified, "king_of_the_hill")
			
			notify("King of the Hill", "Enemy entered park", colour_fail)
		end
	elseif level_id == "arm_for" then
		if not table.contains(notified, "let_them_watch") and self._values.toggle == "off" and self._id == 103311 then
			table.insert(notified, "let_them_watch")
			
			notify("Let Them Watch", "Sniper died", colour_fail)
		end
	elseif level_id == "big" then
		if not table.contains(notified, "matrix_with_lasers") and difficulty_to_index(Global.game_settings.difficulty) >= 7 and self._values.toggle == "off" and self._id == 106250 then
			table.insert(notified, "matrix_with_lasers")
			
			notify("Matrix With Lasers", "Sniper died", colour_fail)
		end
	elseif level_id == "kosugi" then
		if not table.contains(notified, "bushido") and self._values.toggle == "off" and self._id == 104949 then
			table.insert(notified, "bushido")
			
			notify("Bushido", "Must secure all armour first", colour_fail)
		end
	elseif level_id == "tag" then
		if not table.contains(notified, "stalker") and self._values.toggle == "off" and self._editor_name == "disable_achievement_tag_10" then
			table.insert(notified, "stalker")
			
			notify("Stalker", "Garrett unmarked", colour_fail)
		end
	elseif level_id == "man" then
		if not table.contains(notified, "keep_clear_of_the_windows") and self._values.toggle == "off" and self._id == 103957 then
			table.insert(notified, "keep_clear_of_the_windows")
			
			notify("Keep Clear of the Windows", "Sniper died", colour_fail)
		end
	elseif level_id == "alex_1" then
		if not table.contains(notified, "i_am_the_one_who_knocks") and self._values.toggle == "off" and self._id == 101914 then
			table.insert(notified, "i_am_the_one_who_knocks")
			
			notify("I Am the One Who Knocks", "Enemy entered house", colour_fail)
		end
	elseif level_id == "glace" then
		if not table.contains(notified, "caution_wet_floors") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and self._values.toggle == "off" and self._id == 105758 then
			table.insert(notified, "caution_wet_floors")
			
			notify("Caution! Wet Floors", "Player touched ground", colour_fail)
		end
	elseif level_id == "crojob3" or level_id == "crojob3_night" then
		if not table.contains(notified, "oppressor") and self._values.toggle == "off" and self._id == 104364 then
			table.insert(notified, "oppressor")
			
			notify("Oppressor", "Civi died or escaped", colour_fail)
		end
	elseif level_id == "dinner" then
		if not table.contains(notified, "making_a_statement") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and self._values.toggle == "off" and self._id == 103394 then
			table.insert(notified, "making_a_statement")
			
			notify("Making a Statement", "Sniper died", colour_fail)
		end
	elseif level_id == "flat" then
		if not table.contains(notified, "cardio_training") and (self._id == 100049 or self._id == 104879) then
			if self._values.toggle == "on" and self._id == 100049 then
				cardio_training_flag = true
				
				notify("Cardio Training", "Enabled, open the basement", colour_alert)
			elseif cardio_training_flag and self._values.toggle == "off" and self._id == 104879 then
				table.insert(notified, "cardio_training")			
				
				notify("Cardio Training", "Out of time", colour_fail)
			end			
		end
	elseif level_id == "watchdogs_2" then
		if not table.contains(notified, "out_of_bounds") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and self._values.toggle == "off" and self._id == 102382 then
			table.insert(notified, "out_of_bounds")
			
			notify("Out of Bounds", "Enemy entered warehouse", colour_fail)
		end
	elseif level_id == "escape_overpass_night" then
		if not table.contains(notified, "you_shall_not_pass") and self._values.toggle == "off" and self._id == 102471 then
			table.insert(notified, "you_shall_not_pass")
			
			notify("You Shall Not Pass!", "Enemy entered overpass", colour_fail)
		end
	elseif level_id == "chas" then
		if not table.contains(notified, "keep_breathing_that_fresh_air") and self._values.toggle == "off" and (self._id == 101397 or self._id == 100907) then
			table.insert(notified, "keep_breathing_that_fresh_air")
			
			if self._id == 101397 then
				notify("Keep Breathing that Fresh Air", "Alarm cannot be disabled", colour_fail)
			elseif self._id == 100907 then
				notify("Keep Breathing that Fresh Air", "Gas deployed", colour_fail)
			end
		end
	elseif level_id == "chca" then
		if not table.contains(notified, "master_of_floatation") and self._values.toggle == "off" and difficulty_to_index(Global.game_settings.difficulty) >= 6 and self._id == 103371 then
			table.insert(notified, "master_of_floatation")
			
			notify("Master of Floatation", "Civilian died", colour_fail)
		end
	elseif level_id == "pex" then
		if not table.contains(notified, "low_murder_rate") and self._values.toggle == "off" and self._id == 103763 then
			table.insert(notified, "low_murder_rate")
			
			notify("Low Murder Rate", "Someone died", colour_fail)
		end
	elseif level_id == "mus" then
		if not table.contains(notified, "the_war_room") and difficulty_to_index(Global.game_settings.difficulty) >= 5 and (self._id == 101167 or self._id == 101168) then
			if self._values.toggle == "on" and self._id == 101167 then
				notify("The War Room", "Kill count enabled", colour_alert)
			elseif self._values.toggle == "off" and self._id == 101168 then
				notify("The War Room", "Kill count disabled", colour_alert)
			end	
		end
	end
	
	original_function(self, ...)
end

function notify(achievement, message, colour)
	managers.chat:_receive_message(1, achievement, message, colour)
end